#!/usr/bin/python3
"""
 Corso di Pyton per AIAM, Marcello Galli, Giugno 2023

 Esercizio:
 Stringhe e sequenze 

 Uso:
 python3
 >>>import Es03_stringhe as Es3

 >>># eventualmente
 >>>import imp
 >>>imp.reload(Es3)

                                   
"""

a='123456789"0' # fra singoli apici, contiene apici doppi
b="123456789'0" # fra doppi apici, contiene apici singoli 
c="abc" "def"   # stringhe di seguito vengono concatenate 
d=""            # stringa vuota
e=''' stringa
     multilinea '''
print("alcune stringhe: ",a," ",b," ",c," stringa vuota:",d,"\n",e)

f="  \\  \n backspace\b tab:\t vtab:\v apici\" bell:\b"

#stringa raw non interpreta i \, viene preceduta da 'r': 

fr=r'"  \\  \n backspace\b tab:\t vtab:\v apici\" bell:\b"'

print("\nstringa con caratteri speciali, preceduti da \\  :")
print("la stringa e':\n",fr,"\n il formato 'raw' ( r'stringa') mi permette di stamparla" )
print("ma se interpreta i caratteri speciali vedo:")
print(f)


g=" aaaaaaaa\
 bbbbbb : sta su una linea sola; \\n non e' considerato "
 
print("\nstringa con newline escaped by \\ : ")
print(g)

print("\n----- somma e ripetizione di stringhe ------")

a='123' ; b='abc' ; c=a+b ; print("a='123' ; b='abc' ; c=a+b => ",c)
a='123' ; b=a*3 ; print("a='123' ; b=a*3 => ",b)


print("\n------  stringhe come sequenze-----") 

a='0123456' 

print("a='0123456'")

print("a[0]  => ", a[0] ," : indici partono da zero" )
print("a[1]  => ", a[1]  )   
print("a[-1] => ", a[-1]," : indici negativi partono dalla fine" )   
print("a[-2] => ", a[-2] )  

print(" -- slicing --")

print("a[:] => ",a[:],"  : tutta la stringa ")
print("a[0:] => ",a[0:] )
print(" a[:] => ",a[:])
print("a[:0]  => ","  : e' la stringa vuota") 

print("a[0:2]  => ", a[0:2]," : slice: estremo destro escluso ")   
print("a[1:3] => ",  a[1:3] )   
print("a[:-1] => ",  a[:-1], " : -1 :ultimo, ma estremo destro escluso" )   
print("a[-3:-1] => ", a[-3:-1] ) 
print("a[-1:-3] => ", a[-1:-3]," :  la stringa vuota" ) 

print("\n Si puo' anche indicare uno step con cui si estraggono i caratteri") 

print("a[1::2] => ",a[1::2]," : dall'elemento 1 alla fine della stringa, passo 2")        
print("a[1::3] => ",a[1::3]," : un elemento ogni 3 ")		 

print("\n assegnazione multiple per seperare gli elementi:")
f1,f2,f3='abc'
print("f1,f2,f3='abc' : f1=> ",f1," f2=>",f2," f3=>",f3)

print("\n 'in' : test per sottostringhe: ")

print(" '0'  in a  => ",'0'  in a)
print(" '01' in a  => ",'01' in a)
print(" '09' in a  => ",'09' in a)

print("\n ----- for, iteratore su sequenze -----")
print("for i in a: ")
print("   print('i')")

for i in a :
   print(i)
   
print("\n ----- % operatore di formattazione ---")

a=3
b=7.9E3
c=' xxx %s yyy %i zzz %f '% ('000',a,b)
cr=r"' xxx %s yyy %i zzz %f '% ('000',a,b)"

print(' a=3 ; b=7.9E3 ; c=',cr," => ",c)


x=3 ; 
print("'%2d %5d %10d' % (x, x*x, x*x*x) => ",'%2d %5d %10d' % (x, x*x, x*x*x))     


print("\n ----- alcune funzioni per le stringhe ------")

print("conversione da stringa a intero:  int(a) => ", int(a) )
print("conversioneda intero  a stringa: str(450) => ",str(450))
print("conversioneda float   a stringa: str(1.6E3) => ",str(1.6E3))
print("conversioneda stringa a float:   float('32.1') => ",float(32.1)) 

print()


a='0123456'
b='abadafag'
print("a='0123456'") 
print("b='abadafag'")

print("len(a) => ", len(a),"  numero di caratteri della stringa") 
print("min(a) => ", min(a),"  il carattere piu' piccolo (nella sequenza dei caratteri ASCII)")
print("max(a) => ", max(a))
print("min(b) => ", min(b))
print("max(b) => ", max(b))

print("\nb.capitalize() => ", b.capitalize()," : prima lettera maiuscola (capitalized)")
print("b.upper()      => ", b.upper() ," : fa maiuscolo")
print("b.lower()      => ", b.lower() ," : fa minuscolo ")
print("' un titolo'.title() => ",' un titolo'.title()," : singole parole capitalized")  

print("\nb.replace('a','X')   => ",b.replace('a','X')," : carattere a in X ")
print("b.replace('a','X',3) => ",b.replace('a','X',2)," : sostituzione per le prime 2 sottostringhe") 
                      

print() 
print(" -------- esercizio concluso correttamente ---") 
print() 






 

