#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun May 14 12:29:26 2023

@author: marc
"""

def makedict(anni):
    """funzione makedict
    crea una struttura td di dizionari nested
    che contengono valori per certe date,
    in modo da potersi riferire ai valori con
    td[anno][mese][giorno] 
    gli anni sono nel dizionario in argomento
    """
    td={}              # dizionario vuoto
    for anno in anni:  # itero sugli anni forniti
      td[anno]={}      # dizionario vuoto per i valori dell'anno
      for mese in range(1,13):
          td[anno][mese]={} # dizionario per i valori dei giorni del mese
    return td 

anni=[2021,2022]            # anni che voglio trattare
filename="Meteo2122.csv"    # nome del file coi dati

tmedia=makedict(anni)   # uso la funzione per farmi il dizionario

#  apro il file in lettura
f=open(filename)

linee=f.readlines()
f.close()

for linea in linee:
    data,tmin,tmed,tmax,humid,rain,tsoil=linea.split(";")
    if data[2] != '/' : continue 
    giorno,mese,anno=data.split("/")
    giorno=int(giorno)
    mese=int(mese)
    anno=int(anno)
    tmedia[anno][mese][giorno]=float(tmed)
    
    
print("temperatura media del 1/2/2021 ",tmedia[2022][2][1])    

print("temperature medie di marzo 2021",tmedia[2021][3])

diff=[]

for k in tmedia[2021][3]:
    d=tmedia[2022][3][k]-tmedia[2021][3][k]
    diff.append(d)
    

print("variazione temperatura media di marzo ",diff )   

for d in diff:
    print("variazione ->  %5.1f"%(d))






