#!/usr/bin/python3
"""
 Corso di Pyton per AIAM, Marcello Galli, Giugno 2023

 Esercizio:
 Liste e loro uso 

 Uso:
 python3
 >>>import Es04_liste as Es4

 >>># eventualmente
 >>>import imp
 >>>imp.reload(Es4)

"""
                                   
print("------  liste ----")

A=[0,1,2,3,4,5,6,7,8,9]

print("Una lista: ",A)
print("Creata con: A=[0,1,2,3,4,5,6,7,8,9]")

print("\n liste come reference ")

A1=A         # copio la reference 
A2=A[:]      # copio veramente gli elementi 
A[0]='k'     # A2 non cambia, A1 cambia 
A=[35]       # ridefinisce A, A1, A2 non cambiano

print("A1=A ; A2=A[:] ; A[0]='k' ")
print("A1 cambia: => ",A1)
print("A2 invariato: => ",A2)

print("se ridefinisco A (Es.:A=[3,4])A1 ed A2 restano invariati") 
#print=(" Ma: A=[35] ridefinisce la lista, A1,A2 invariati \n")


B=[0,1,2.333,'a','b'] 

C=[0,1,[2,3,4],'a','b',['kk',12.3],'dd'] 

print("\nlista eterogenea: ",B)
print("lista con liste: ",C)
print("C[2][1] => ",C[2][1])

A=[0,1,2,3,4,5,6,7,8,9]
print("\nA=",A)

print("A[0]  =>",A[0]," : primo elemento" )         

print("A[-1] =>",A[-1]," : ultimo elemento" )

print("A[2:4] =>",A[2:4]," : slice, da posizione 2 a posizione 4 (4 escluso") 

print("A[1:1] =>",A[1:1]," : slice vuoto, in posizione 1, l'estremo destro e' escluso") 
          
A[0]=1.3
print("A[0]=1.3   A =>", A ," : la lista ha elementi mutabili")

del A[3:5]
print("del A[3:5] A =>", A ," : elimina dal numero 3 (compreso) al 5 (escluso)")

A[0:3]=[]
print("A[0:3]=[]  A =>", A ," : elimina i primi 3 elementi (da 0 a 2 ) ")

A[0:3]=['a','b','c']
print("A[0:3]=['a','b','c'] A=>", A ," : sostituisce i primi 3 elementi")

del A[3:5:2]
print("del A[3:5:2] A=>", A ," :  elimina con passo 2: uno si, uno no") 


l=[1,2,3,4,5]
g1,g2,g3,g4,g5=l

print("\n unfolding: \nl=[1,2,3,4,5] \ng1,g2,g3,g4,g5=l")


print("\n Un modo per aggiungere elementi ad una lista:")
kk=[0,1,2]
kk[1:1]=['x','y','z']
print("kk=[0,1,2] ; kk[1:1]=['x','y','z'] =>",kk)
print(" alla slice (vuota) in posizione 1 sostituisco una sequenza,",
              " in questo modo inserisco elementi nella lista")  
kk=[0,1,2]
kk[1:1]='xyz'
print("\nkk=[0,1,2] ; kk[1:1]='xyz' =>",kk," stessa cosa, ma con sequenza di caratteri (stringa)")

kk=[0,1,2]
kk[1:1]=[['x','y','z']]
print("\nkk=[0,1,2] ; kk[1:1]=[['x','y','z']] =>",kk," qui invece ho una lista di liste ")


LL=[1,2,3] ; LLL=['1','2','3'] ; L4=LL+LLL
print("\n Somma di liste le concatena:\n LL=[1,2,3] ; LLL=['1','2','3'] ; LL+LLL => ",L4)

LL*2
print("\nRipetizione liste: LL*2 => ",LL*2)

print("\n------ iteratore range() per scorrere le liste ----\n")


print("for i in range(3):\n   print(i)")
for i in range(3):
   print(i)
   
print("scorrere una lista senza saperne la lunghezza: ")
print("P=[1,2,3] \nfor i in range(len(P)):\n  print(i)") 

P=[1,2,3]
for i in range(len(P)):
  print(i) 
  
  
print("\n------  list comprehension ----")

S=[x*x for x in [1,2,3] ]
print("[x*x for x in [1,2,3] ]=> ",S)

b=[x*x for x in range(3)]                
print("[x*x for x in range(3)] => ",b) 

b=[x for x in range(6) if x%2 ]          
print("[x for x in range(6) if x%2 ] => ",b)

b=[y for x in range(2) for y in [5,6]]   
print("\n[y for x in range(2) for y in [5,6]] => ",b)

print("\n------  alcune funzioni per liste ----")

A.append('v')
print("A.append('v')  A=> ",A," : mette  in fondo")  

a=A.pop()
print("A.pop()  =>",a," A=> ",A," : estrae l'ultimo e lo elimina")

A.insert(3,'vv')
print("A.insert(3,'vv') A=> ",A," : inserisce in posizione 3, spostando gli altri")

A.reverse()
print("A.reverse() => ",A," :  ordine inverso ")

print("A.count('vv') => ", A.count('vv')," : conta quante volte compare 'vv' ")

D=[3,2,1]
D.sort()
print("D=[3,2,1] ; D.sort() D=> ",D," : ordinamento ") 

print("\n --- join e split : liste di stringhe --") 

Z=['a','b','c']
ZZ='_'.join(Z) 

print(" Z=['a','b','c'] ; Z.join('_') => ",ZZ) 

ZZZ=ZZ.split('_')

print(" 'a_b_c'.split('_') => ",ZZZ)

print("'=='.join('abc') => ",'=='.join('abc')," : 'abc' e' una sequenza")


print() 
print(" -------- esercizio concluso correttamente ---") 
print() 
