#!/usr/bin/python3
"""
 Corso di Pyton per AIAMM, Marcello Galli, Giugno 2023

 Esercizio:
  funzioni
 
 Questo esercizio e' per Python3, non va con Python 2

 Uso:
 python3
 >>>import Es09_funzioni as Es9

 >>># eventualmente
 >>>import imp
 >>>imp.reload(Es9)

"""

print("\n------- argomenti ----\n") 

def func(a,b,c=1,d=2,*al,**ad):
    print( "Positional arguments: a,b: ",a,",",b)
    print( "Keywords arguments c,d:",c,",",d)
    print( "list of remaining pos. args:",al)
    print( "list of remaining keyw.args:",ad)
    print()
    return
     
print( " ====> function is:  def func(a,b,c=1,d=2,*al,**ad)" )  
print( " ====>function called as: func(10,20)")
func(10,20)
print( '====>function called as: func(10,20,d="aaa")')
func(10,20,d="aaa")
print( "====>function called as: func(10,20,1,2,'xyz',4,5,6)")
func(10,20,1,2,'xyz',4,5,6)
print( "====>function called as: func(10,20,e=1,f=2,g=3.3)")
func(10,20,e=1,f=2,g=3.3)
print( "====>function called as: func(10,20,30,40,50,e=1,f=2,g=3.3)")
func(10,20,30,40,50,e=1,f=2,g=3.3)
print( "====>function called as: func(10,20,c=[1,2,3],d={'a':1,'b':2})")
func(10,20,c=[1,2,3],d={'a':1,'b':2}) 

print("\n------- attributi ----\n") 

def funz(a):
   """
     funzione semplice
   """
   b=3
   c=33
   return a+b+c 
   
kk=funz(1000)
print( "la funzione produce: kk")

print( "attributo docstring:",funz.__doc__)

print( "local var dict:",funz.__dict__)

print( "name",funz.__name__)

print( "assegno attributo")
funz.a=77
print( "local var dict:",funz.__dict__)


print("\n------- scope ----\n") 


def func(a):
   a=a+b
   return a

def func1(a):
   global gc
   gc=a


print( "definisco b=100")
b=100
print( "==> chiamo func(1) che usa b, definita fuori")
a=func(1)

print( "b  vale sempre:",b)
print( "a e' modificato, ora vale:",a)

print( "\n==> chiamo func1(1) che cambia gc definito  global")
func1(1)
print( "gc (global) da fuori lo vedo come:",gc)

globale=200

print( "ora provo a ridefinire, in una fuc. una var. esterna ")
def func2(a):
   globale=a
   return globale

s=func2(2)
print( "esterna:",globale)
print( "func tornata",s)
print( "la locale ha nascosto la esterna")

print( "\nora creo un errore, modificando la variabile esterna")

def func3(a):
   globale+=a
   return globale

import sys           # per gestire i messaggi dell'eccezione importo questi moduli
import traceback     # se non gestisco l'eccezione il programma si blocca
try:
  func3(5)
except:
  eccname=sys.exc_info()[0]
  print("ERRORE!! viene sollevata l'eccezione: ",eccname," che stampa:\n")
  traceback.print_exc()

print("\n------------ argometi passati by reference. effetti -------\n")   



def cambiaarg(a) : 
   print("argomento:",a)
   a+=7
   print(" a+=7 ",a)
   return a
  
print(" funzione che aggiunge 7 al suo argomento")
print("a=1, cambiaarg(1)")
a=1
cambiaarg(1)
print(" dopo chiamata a non e' modificato:",a)


print("\n funzione che aggiunge 7 agli ementi di una lista")
print(" a=[1,2] ; cambialist(a)")

def cambialist(a) : 
   print("argomento:",a)
   for i in range(0,len(a)):
     a[i]+=7
   print(" entro la funzione: ",a)
   return a

a=[1,2]
cambialist(a)
print(" fuori della funzione, dopo chiamata:",a)


print("\nfunzione che altera un dizionario : dict:{1:1,2:2}") 

def cambiadict(a):
   print("argomento:",a ) 
   for i in a:  # loop su keys
     a[i]+=7
   print(" entro la funzione: ",a)
   return a
   
   
a={1:1,2:2}
cambiadict(a)
print(" fuori della funzione, dopo chiamata a:",a)

print()
print("------- fine esercizio  --------") 
print()

